
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This code generated by: 
 *      Author : thomas
 *      Date   : Fri Jun 20 2003
 */

#include <kdebug.h>

#include "javaaddaccessormethod.h"

#include "../attribute.h"
#include "../classifiercodedocument.h"
#include "../umlobject.h"
#include "../umlrole.h"

#include "javaclassifiercodedocument.h"
#include "javacodeclassfield.h"
#include "javacodedocumentation.h"

// Constructors/Destructors
//  

JavaAddAccessorMethod::JavaAddAccessorMethod ( JavaCodeClassField * field)
   : CodeAccessorMethod ( (CodeClassField*) field )
{
	updateMethodDeclaration();
	updateContent();
}

JavaAddAccessorMethod::~JavaAddAccessorMethod ( ) { }

// Other methods
//

/** Save the XMI representation of this object
 * @return      bool    status of save
 */
bool JavaAddAccessorMethod::saveToXMI ( QDomDocument & doc, QDomElement & root ) {
        bool status = true;

        QDomElement blockElement = doc.createElement( "codeaccessormethod" );

        // set attributes
        setAttributesOnNode(doc, blockElement);

        root.appendChild( blockElement );

        return status;
}

void JavaAddAccessorMethod::setAttributesOnNode ( QDomDocument & doc, QDomElement & blockElement)
{

        // set super-class attributes
        CodeAccessorMethod::setAttributesOnNode(doc, blockElement);

        // set local attributes now

}

/**
 * load params from the appropriate XMI element node.
 */
void JavaAddAccessorMethod::loadFromXMI ( QDomElement & root )
{
        setAttributesFromNode(root);
}

void JavaAddAccessorMethod::setAttributesFromNode( QDomElement & root)
{

        // set attributes from superclass method the XMI
        CodeAccessorMethod::setAttributesFromNode(root);

        // load local stuff

}

void JavaAddAccessorMethod::updateContent( )
{

	CodeClassField * parentField = getParentClassField();
	JavaCodeClassField * javafield = (JavaCodeClassField*)parentField;
        QString fieldName = javafield->getFieldName();
        setText(fieldName+".add(object);");
}

void JavaAddAccessorMethod::updateMethodDeclaration() 
{

	CodeClassField * parentField = getParentClassField();
	ClassifierCodeDocument * doc = parentField->getParentDocument();

	//JavaClassifierCodeDocument * javadoc = dynamic_cast<JavaClassifierCodeDocument*>(doc);
	JavaClassifierCodeDocument * javadoc = (JavaClassifierCodeDocument*) doc;
	JavaCodeClassField * javafield = (JavaCodeClassField*)parentField;

        QString strVis = javadoc->scopeToJavaDecl(getParentClassField()->getVisibility());
        QString fieldName = javafield->getFieldName();
        QString fieldType = javafield->getTypeName();
        QString objectType = javafield->getListObjectType();
        QString methodName = "add"+javadoc->capitalizeFirstLetter(fieldName);
	QString endLine = javadoc->getNewLineEndingChars();

        // method
        JavaCodeDocumentation * header = new JavaCodeDocumentation(javadoc,"");
	if(!getParentObject()->getDoc().isEmpty())
		header->setText("Add an object of type "+objectType+" to the List "+fieldName+endLine+getParentObject()->getDoc()+endLine);
	setComment(header);

        setStartMethodText(strVis+" void "+methodName+" ( "+objectType+" object ) {");
        setEndMethodText("}");

	setOverallIndentationLevel(1);
}

#include "javaaddaccessormethod.moc"
