
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This code generated by: 
 *      Author : thomas
 *      Date   : Fri Jun 20 2003
 */

#include <kdebug.h>

#include "javagetaccessormethod.h"

#include "../attribute.h"
#include "../classifiercodedocument.h"
#include "../umlobject.h"
#include "../umlrole.h"

#include "javaclassifiercodedocument.h"
#include "javacodeclassfield.h"
#include "javacodedocumentation.h"

// Constructors/Destructors
//  

JavaGetAccessorMethod::JavaGetAccessorMethod ( JavaCodeClassField * field)
   : CodeAccessorMethod ( (CodeClassField*) field ) 
{
        updateMethodDeclaration();
	updateContent();
}

JavaGetAccessorMethod::~JavaGetAccessorMethod ( ) { }

// Other
//

/** Save the XMI representation of this object
 * @return      bool    status of save
 */
bool JavaGetAccessorMethod::saveToXMI ( QDomDocument & doc, QDomElement & root ) {
        bool status = true;

        QDomElement blockElement = doc.createElement( "codeaccessormethod" );

        // set attributes
        setAttributesOnNode(doc, blockElement);

        root.appendChild( blockElement );

        return status;
}

void JavaGetAccessorMethod::setAttributesOnNode ( QDomDocument & doc, QDomElement & blockElement)
{

        // set super-class attributes
        CodeAccessorMethod::setAttributesOnNode(doc, blockElement);

        // set local attributes now

}

/**
 * load params from the appropriate XMI element node.
 */
void JavaGetAccessorMethod::loadFromXMI ( QDomElement & root )
{
        setAttributesFromNode(root);
}

void JavaGetAccessorMethod::setAttributesFromNode( QDomElement & root)
{

        // set attributes from superclass method the XMI
        CodeAccessorMethod::setAttributesFromNode(root);

        // load local stuff

}

// we basically want to update the body of this method
void JavaGetAccessorMethod::updateContent( )
{
	CodeClassField * parentField = getParentClassField();
	JavaCodeClassField * javafield = (JavaCodeClassField*)parentField;
        QString fieldName = javafield->getFieldName();
        setText("return "+fieldName+";");
}

// we basically want to update the start text of this method
void JavaGetAccessorMethod::updateMethodDeclaration() 
{

	CodeClassField * parentField = getParentClassField();
	ClassifierCodeDocument * doc = parentField->getParentDocument();

	//JavaClassifierCodeDocument * javadoc = dynamic_cast<JavaClassifierCodeDocument*>(doc);
	JavaClassifierCodeDocument * javadoc = (JavaClassifierCodeDocument*) doc;
	JavaCodeClassField * javafield = (JavaCodeClassField*)parentField;

        QString strVis = javadoc->scopeToJavaDecl(getParentClassField()->getVisibility());
        QString fieldName = javafield->getFieldName();
        QString fieldType = javafield->getTypeName();
        QString methodName = "get"+javadoc->capitalizeFirstLetter(fieldName);
	QString endLine = javadoc->getNewLineEndingChars();

        // get method
        JavaCodeDocumentation * header = new JavaCodeDocumentation(javadoc);
	if(!getParentObject()->getDoc().isEmpty())
		header->setText("Get the value of "+fieldName+endLine+getParentObject()->getDoc()+endLine+"@return the value of "+fieldName);
	setComment(header);

        setStartMethodText(strVis+" "+fieldType+" "+methodName+" ( ) {");
        setEndMethodText("}");

	setOverallIndentationLevel(1);
}



#include "javagetaccessormethod.moc"
